* = $0000

; handy macros
!macro foo { lda #$F8 }

; Constants
SUCCESS = $D3

; ===== JUMP
	lda #0
	jmp jmp_ahead
	halt

jmp_back:
	jmp jmp_done
		
jmp_ahead:
	jmp jmp_back
	halt
	
jmp_done:		

; ===== CONDITIONAL BRANCHES	
	lda #$ff
	add #0 ; clears carry
	bcs + ; bcs not taken
	bcc ++ ; bcc taken
+	halt
++  sub #0 ; sets carry
	bcc + ; bcc not taken
	bcs ++ ; bcs taken
+	halt
++	

	lda #$ff
	add #0 ; clears z 
	beq + ; beq not taken
	bne ++ ; bne taken
+	halt
++  add #1 ; sets z
	bne + ; bne not taken
	beq ++ ; beq taken
+	halt
++	

; ===== LDA immediate, CMP immediate
	lda #$00 ; zero
	bne +
	beq ++
+	halt
++	lda #$7F ; non-zero
	beq +
	bne ++
+	halt
++	cmp #$7F ; equal
	bne +
	bcc +
	jmp ++
+	halt
++	cmp #$07 ; greater than
	beq +
	bcc +
	jmp ++
+	halt
++	cmp #$FF ; less than
	beq +
	bcs +
	jmp ++
+	halt

; ===== STA, LDA abs
++	lda #$B8
    sta $0300
	lda #$4E
	sta $0301
	cmp #$4E ; make sure sta doesn't alter A
	beq +
	halt
+	lda $0300
	cmp #$B8
	beq +
	halt
+	lda $0301
	cmp #$4E
	beq +
	halt
	
; ===== CMP abs
+	lda #$4E
	cmp $0301
	beq +
	halt
+	lda #$B8
	cmp $0300
	beq +
	halt

; ===== LDX immediate
+	ldx #$00 ; zero
	bne +
	beq ++
+	halt
++	ldx #$FE ; non-zero
	beq +
	bne ++
+	halt

; ===== INX/DEX
++	inx ; now FF
	beq +
	bne ++
+	halt
++	inx ; now 0
	bne +
	beq ++
+	halt
++	ldx #2
	dex ; now 01
	beq +
	bne ++
+	halt
++	dex ; now 0
	bne +
	beq ++
+	halt

; ===== STX,LDX abs
++	ldx #$FF
    stx $0300
	ldx #$FE
	stx $0301
	beq + ; make sure stx doesn't alter X
	inx
	beq + ; make sure stx doesn't alter X
	inx
	bne + ; make sure stx doesn't alter X
	jmp ++
+	halt
++  ldx $0300
	beq +
	inx
	bne +
	jmp ++
+	halt
++	ldx $0301
	beq +
	inx
	beq +
	inx
	bne +
	jmp ++
+	halt

; ===== LDA,STA abs,x
++	ldx #4
	lda #$B1
	sta $0300,x
	lda #0
	ldx #1
	lda $0303,x
	cmp #$B1
	beq +
	halt
	
; ===== CMP abs,x	
+ 	lda #$B0
	ldx #2
	cmp $0302,x
	bne +
	halt
+	lda #$B1
	cmp $0302,x
	beq +
	halt

; ===== NOR immediate
+	lda #$E3
	nor #$31 ; result should be $0C
	cmp #$0C
	beq +
	halt
+	lda #$E3
	nor #$3D ; result should be $00
	beq +
	halt

; ===== NOR abs
+	lda #$31
	sta $0300
	lda #$E3
	nor $0300 ; result should be $0C
	cmp #$0C
	beq +
	halt
+	lda #$3D
	sta $0300
	lda #$E3
	nor $0300 ; result should be $00
	beq +
	halt
	
; ===== NOR abs,x
+	lda #$31
	sta $0302
	lda #$E3
	ldx #2
	nor $0300,x ; result should be $0C
	cmp #$0C
	beq +
	halt
+	lda #$3D
	sta $0302
	lda #$E3
	ldx #2
	nor $0300,x ; result should be $00
	beq +
	halt

; ===== ADD
+	lda #$33
	add #$41 ; basic add
	beq +
	bcs +
	jmp ++
+	halt
++	cmp #$74
	beq +
	halt
+	lda #$FF
	add #$FE ; should set C
	beq +
	bcc +
	jmp ++
+	halt	
++  cmp #$FD
	beq +
	halt
+	lda #$70
	add #$90 ; should set Z,C
	bne +
	bcc +
	jmp ++
+	halt	
++  cmp #$00	
	beq +
	halt
	
; ===== ADD abs
+	lda #$34
	sta $0300
	lda #$41
	add $0300 ; result should be $75
	cmp #$75
	beq +
	halt
	
; ===== ADD abs,x
+	lda #$34
	sta $0302
	lda #$41
	ldx #2
	add $0300,x ; result should be $75
	cmp #$75
	beq +
	halt
	

; ===== SUB
+	lda #$33
	sub #$21 ; basic sub
	beq +
	bcc +
	jmp ++
+	halt
++	cmp #$12
	beq +
	halt
+	lda #$FF
	sub #$FE ; should set C
	beq +
	bcc +
	jmp ++
+	halt	
++  cmp #$01
	beq +
	halt
+	lda #$70
	sub #$90 ; should clear C,Z
	beq +
	bcs +
	jmp ++
+	halt	
++  cmp #$E0	
	beq +
	halt
+	lda #$70
	sub #$70 ; should set C, Z
	bcc +
	bne +
	jmp ++
+	halt
++	cmp #0
	beq +
	halt
	
; ===== SUB abs
+	lda #$21
	sta $0300
	lda #$34
	sub $0300 ; result should be $13
	cmp #$13
	beq +
	halt
	
; ===== SUB abs,x
+	lda #$21
	sta $0302
	lda #$34
	ldx #2
	sub $0300,x ; result should be $13
	cmp #$13
	beq +
	halt	
			
; ===== PHA, PLA
+	lda #$1
	pha
	lda #$2
	pha
	lda #0
	pla
	cmp #$2
	beq +
	halt
+	pla
	cmp #$1
	beq +
	halt

; ===== PHX, PLX
+	ldx #$1
	phx
	ldx #$2
	phx
	ldx #0
	plx ; should be 2
	dex
	dex
	beq +
	halt
+	plx ; should be 1
	dex
	beq +
	halt

; ===== CALL, RETURN
+	call sub1
	lda #$A3
	cmp $0380
	beq +
	halt
+	lda #$79
	cmp $0381
	beq +
	halt

; ===== done
+	lda #SUCCESS
	halt
	
sub1:
	lda #$22
	sta $0380
	call sub2
	lda #$A3
	sta $0380
	return
	
sub2:
	lda #$79
	sta $0381
	return
	